# remirepo/fedora spec file for php-nette-caching
#
# Copyright (c) 2015-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    1231735b5135ca02bd381b70482c052d2a90bdc9
#global gh_date      20150728
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     nette
%global gh_project   caching
%global ns_vendor    Nette
%global ns_project   Caching
%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.5.6
%global specrel 1
Release:        %{?gh_date:1%{specrel}.%{?prever}%{!?prever:%{gh_date}git%{gh_short}}}%{!?gh_date:%{specrel}}%{?dist}.3
Summary:        Nette Caching Component

Group:          Development/Libraries
License:        BSD or GPLv2 or GPLv3
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        %{name}-%{version}-%{gh_short}.tgz
# pull a git snapshot to get test sutie
Source1:        makesrc.sh

BuildArch:      noarch
BuildRequires:  php-composer(theseer/autoload)
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-pdo
BuildRequires:  php-date
BuildRequires:  php-reflection
BuildRequires:  php-composer(%{gh_owner}/finder) >= 2.2
BuildRequires:  php-composer(%{gh_owner}/utils) >= 2.4
# From composer.json, "require-dev": {
#               "nette/tester": "~2.0",
#               "nette/di": "^2.4 || ~3.0.0",
#               "latte/latte": "^2.4",
#               "tracy/tracy": "^2.4"
BuildRequires:  php-composer(%{gh_owner}/tester) >= 2.0
BuildRequires:  php-composer(%{gh_owner}/di) >= 2.4
BuildRequires:  php-composer(latte/latte) >= 2.4
BuildRequires:  php-composer(tracy/tracy) >= 2.4
%endif

# from composer.json, "require": {
#               "php": ">=5.6.0",
#               "nette/finder": "^2.2 || ~3.0.0",
#               "nette/utils": "^2.4 || ~3.0.0"
Requires:       php(language) >= 5.6
Requires:       php-composer(%{gh_owner}/finder) >= 2.2
Requires:       php-composer(%{gh_owner}/finder) <  4
Requires:       php-composer(%{gh_owner}/utils) >= 2.4
Requires:       php-composer(%{gh_owner}/utils) <  4
# from phpcompatinfo report for version 2.3.3
Requires:       php-pdo
Requires:       php-reflection
Requires:       php-date
%if 0%{?fedora} > 21
Suggests:       php-pecl(memcache)
Suggests:       php-pecl(memcached)
%endif

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
Cache accelerates your application by storing data, once hardly retrieved,
for future use.

To use this library, you just have to add, in your project:
  require_once '%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
: Generate a classmap autoloader
phpab --output src/%{ns_project}/autoload.php src

cat << 'EOF' | tee -a src/%{ns_project}/autoload.php
// Dependencies
require_once '%{php_home}/%{ns_vendor}/Finder/autoload.php';
require_once '%{php_home}/%{ns_vendor}/Utils/autoload.php';
EOF


%install
mkdir -p     %{buildroot}%{php_home}/%{ns_vendor}
cp -pr src/* %{buildroot}%{php_home}/%{ns_vendor}/


%check
%if %{with_tests}
: Ignore tests which require memcache
rm tests/Storages/*Memcache*

export LANG=C.UTF-8

: Generate autoloader
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{php_home}/Tester/autoload.php';
require_once '%{php_home}/Latte/autoload.php';
require_once '%{php_home}/%{ns_vendor}/DI/autoload.php';
require_once '%{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';
EOF

: Run test suite in sources tree
ret=0
for cmd in php php56 php70 php71 php72; do
   if which $cmd; then
      $cmd %{_bindir}/nette-tester --colors 0 -p $cmd -C tests -s || ret=1
   fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license license.md
%doc readme.md contributing.md
%doc composer.json
%{php_home}/%{ns_vendor}/%{ns_project}
%{php_home}/%{ns_vendor}/Bridges


%changelog
* Sun Nov 18 2018 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 2.5.6-1.3
- Use C.UTF-8 locale
  See https://fedoraproject.org/wiki/Changes/Remove_glibc-langpacks-all_from_buildroot

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.6-1.2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.6-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Fri Sep  8 2017 Remi Collet <remi@remirepo.net> - 2.5.6-1
- Update to 2.5.6

* Wed Aug 30 2017 Remi Collet <remi@remirepo.net> - 2.5.5-1
- Update to 2.5.5

* Sun Aug  6 2017 Remi Collet <remi@remirepo.net> - 2.5.4-1
- Update to 2.5.4

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.3-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Thu Feb  2 2017 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- update to 2.5.3

* Wed Oct 19 2016 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2

* Tue Aug  2 2016 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- update to 2.5.1
- raise dependency on PHP >= 5.6
- raise dependency on nette/utils >= 2.4

* Mon Feb 22 2016 Remi Collet <remi@fedoraproject.org> - 2.3.5-1
- update to 2.3.5
- run test suite with both PHP 7 and 7 when available

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.4-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Nov 30 2015 Remi Collet <remi@fedoraproject.org> - 2.3.4-1
- update to 2.3.4

* Tue Oct 20 2015 Remi Collet <remi@fedoraproject.org> - 2.3.3-1
- initial package